
public class Set<T>
{
    private Node<T> first;
    private int length; 
    private Node<T> last;
    /** 
     * Konstruktor, legt leeres Set an
     */
    public Set(){
        this.first = null;
        length = 0;
        this.last= null;
    }
    
    /**
     * Gibt zurück, ob die Liste leer ist (true heißt leer)
     */
    public boolean isEmpty(){
        return this.first == null;
    }
    
    /**
     * Gibt die Länge der Liste zurück
     */
    public int size(){
        return this.length;
    }

    public T get (int n){
        Node<T> current = this.first;
        for ( int i = 0; i < n ; i++ ){
            if (current == null)return null;
            current = current.next;
        }
        if (current == null ) return null;
        return current.wert;
    }
    
    private Node<T> getNode (int n){
        Node<T> current = this.first;
        for ( int i = 0; i < n ; i++ ){
            if (current == null)return null;
            current = current.next;
        }
        if (current == null ) return null;
        return current;
    }
    
    public void add (T val){
        if (!this.contains(val)){
            Node<T> added = new Node<T>(val);
            if (this.first == null){
                this.first = added;
                this.last = added;
            }
            else{ this.last.next = added;
            this.last = added;
            }
        }
    }

    public boolean contains (T val){
        Node<T> current = this.first;
        while(current != null){
            if(current.wert == val) return true;
            current = current.next;
        }
        return false;
    }

    public void remove(T val){
        if(!this.contains(val))return;
        Node<T> current = this.first;
        while(current.next.wert != val){
            current = current.next;
        }
        current.next.next = current.next;
    }
    
    public Set<T> intersection(Set<T> s){
        Set<T> tmp  = new Set<T>();
        Node<T> current = this.first;
        while(current != null){
            if (s.contains(current.wert)) tmp.add(current.wert);
            current=current.next;
        }
        return tmp;
    }
    
    
    /*public String toString(){
        Node <T> current = this.first;
        String tmp = "";
        while (current != null){
            tmp = tmp + (String)current.wert;
            current = current.next;
        }
        return tmp;
    }*/
}
